// ̃vOPM Plus 5.21ŃRpC܂

#pragma sfr

#include "stdio.h"
#include "trgbios.h" // gZBIOS̃T[rX[`ĂяôɕKv
#include "commands.h"

/*----------------------------- }N` -----------------------------*/
typedef unsigned char   UB;
typedef signed   char    B;
typedef unsigned short  UH;
typedef signed   short   H;
typedef unsigned long   UW;
typedef signed   long    W;

/*==============================*/
/* status                       */
/*==============================*/
#define STS_TXBFULL       ( 0x02 )            /* bit 1 set...TX buff full    */
#define STS_RXBFULL       ( 0x04 )            /* bit 2 set...RX buff full    */
#define STS_DV_MSK        ( 0x0F )            /* mask                        */

#define STS_CONNECT       ( 0x00 )            /* bit 4 reset...com open    */
#define STS_DISCONNECT    ( 0x10 )            /* bit 4 set.....com close    */
#define STS_FC_MSK        ( 0xF0 )            /* mask                        */

/*==============================*/
/*                              */
/*==============================*/
#define CSAD        P1.3
#define CSDA        P1.4

/*----------------------------- ^g` -----------------------------*/
typedef struct {                              /*                             */
    UB    ucStatus;                           /* status                    */
    UB    ucBaudrate[4];                      /* Baudrate                    */
    UB    ucStopbit;                          /* Stopbit                    */
    UB    ucParity;                           /* Parity                    */
    UB    ucDatabit;                          /* Databit                    */

    UB    RxByteLen;                          /* USB Recv Byte length()        */
    UB    TxByteLen;                          /* USB Send Byte length(M)    */
} tstUSBSTATUS;



/*--------------------------------------------------------------------*/
/* [֐] ð擾                                                 */
/* [  ] UB getStatus(tstUSBSTATUS *p)                             */
/* [  ] p : ð\߲                                      */
/* [o  ] ڑ                                                  */
/* [T  v] USB̽ð擾                                      */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                                     */
/*--------------------------------------------------------------------*/
UB getStatus(tstUSBSTATUS *p) {
    #asm
	db	0C5h				;_svUSB_getstatus
    #endasm
    return(p->ucStatus & STS_DISCONNECT);
}
/*--------------------------------------------------------------------*/
/* [֐] ðAM޲Ď擾                                       */
/* [  ] UH getRxcb(void)                                          */
/* [  ] none                                                      */
/* [o  ] ޲:ð޲āA޲:Mް                    */
/* [T  v] USBðƎM޲Ă擾                              */
/*          0xFF00̏ꍇAMްȂӖ                      */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                                     */
/*--------------------------------------------------------------------*/
UH getRxcb(void) {
    #asm
	db	0C7h				;_svUSB_getrecvcount
    #endasm
}
/*--------------------------------------------------------------------*/
/* [֐] ޲ASCIIϊM                                         */
/* [  ] void txconv(UB byt)                                       */
/* [  ] byt : Mް                                            */
/* [o  ] none                                                      */
/* [T  v] t`qsް޲āASCIIϊM                 */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                                     */
/*--------------------------------------------------------------------*/
UH getRecv(void) {
    #asm
	db	0C9h				;_svUSB_byteread
    #endasm
}
/*--------------------------------------------------------------------*/
/* [֐] ް񑗐M                                                */
/* [  ] UB putSend(UB *lpb,UB cnt)                                */
/* [  ] lpb : Mް߲                                      */
/*          cnt : Mް                                          */
/* [o  ] Mް                                                */
/* [T  v] wް𑗐M                                        */
/*          s͑Mꐔw萔ƂƂȂ                        */
/* [Q  ]                                                           */
/* [  ] Ăяoޯ̧ق̊Ǘ͍s                      */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                                     */
/*--------------------------------------------------------------------*/
UB putSend(UB *lpb,UB cnt) {
    #asm
	pop	de				;return
	pop	bc				;cnt
	push	bc				;cnt
	push	de				;return
	push	bc				;cnt
	db	0CBh				;_svUSB_datawrite
	pop	ax				;
    #endasm
}
/*--------------------------------------------------------------------*/
/* [֐] ްM                                                  */
/* [  ] void snddata(UB ch)                                       */
/* [  ] ch : M                                             */
/* [o  ] none                                                      */
/* [T  v] ݒ蕶𑗐Mޯ̧ق̏ԂłM                  */
/* [Q  ]                                                           */
/* [  ] Mޯ̧ײČðf                           */
/*          Ұɂ芄荞ݽð̕ωقȂ̂ŗv            */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                                     */
/*--------------------------------------------------------------------*/
static void snddata(UB ch) {
    tstUSBSTATUS  st;

    while(1) {
        if(putSend(&ch,1) != 0) {
            break;
        }
        if(getStatus(&st) & STS_DISCONNECT) {
            break;
        }
    }
}

/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
static void spi_wr(UB sd) {
    SOTB10 = sd;
    while(CSIM10.0);            /* csot10 == 1 ̊(łȂ) */
}
/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
static UB spi_rd(void) {
    SOTB10 = 0;
    while(CSIM10.0);            /* csot10 == 1 ̊(łȂ) */
    return(SIO10);              /* ǂݏo */
}
/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
static UH get_ad(UB ch) {
    UB  cmd = (ch == 0)?  0xA0 : 0xE0;
    UB  hi;
    UB  lo;

    CSAD = 0;
    spi_wr(0x01);  /* start */
    spi_wr(cmd);
    hi = SIO10 & 0x0F;
    lo = spi_rd();
    CSAD = 1;
    return(((unsigned short)hi << 8) | lo);
}

/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
void snd_ad(void) {
    UH  ad;

    ad = get_ad(0);
    snddata((UB)(ad >> 8));
    snddata((UB)(ad));
    ad = get_ad(1);
    snddata((UB)(ad >> 8));
    snddata((UB)(ad));
}
/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
void put_da(UB adr,UB *lpb) {
    UB  sd1;
    UB  sd2;

    sd1 = (UB)((adr << 4) | (lpb[0] << 2) | (lpb[1] >> 6));
    sd2 = (UB)(lpb[1] << 2);
    CSDA = 0;
    spi_wr(sd1);
    spi_wr(sd2);
    CSDA = 1;
    sd1 += 0x10;
    CSDA = 0;
    spi_wr(sd1);
    spi_wr(sd2);
    CSDA = 1;
}
/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
void spi_ini(void) {
    P1.0  = 1;      /* SCK10=H(enable AND logic) */
    P1.1  = 0;      /* SI10 */
    P1.2  = 0;      /* SO10 */
    P1.3  = 1;      /* CS#=H AD */
    P1.4  = 1;      /* CS#=H DA */
    PM1.0 = 0;      /* SCK10=output */
    PM1.1 = 1;      /* SI10=input */
    PM1.2 = 0;      /* SO10=output */
    PM1.3 = 0;      /* CS#=output AD */
    PM1.4 = 0;      /* CS#=output DA */
//    CSIM10 = 0x00;
    CSIM10 = 0x40;
/*    CSIM10 = B01000000;*/
/*              |||||||+--- CSOT10 : ʐMԃtO (RO) */
/*              |||||||         0=ʐM~, 1=ʐM */
/*              ||||+++---- reserved */
/*              |||+------- DIR10 : 擪rbg̎w */
/*              |||             0=MSB, 1=LSB */
/*              ||+-------- reserved */
/*              |+--------- TRMD10 : M[h̐ */
/*              |               0=M[hiM֎~j, 1=M[h */
/*              +---------- CSIE10 :  3VAI/O[h̓̐ */
/*                              0=֎~CH񓯊Zbg */
/*                              1=싖 */
    CSIC10 = 0x1E;
/*    CSIC10 = B00011110;*/
/*              |||||+++--- CKS10[2:0] : CSI10̃VAENbN̑I */
/*              |||||          000=8MHz  , 001=4MHz  , 010=2MHz  , 011=1MHz */
/*              |||||          100=500kHz, 101=250kHz, 110=125kHz, 111=X[u[h */
/*              |||++------ CKP10|DAP10 : f[^M^C~O̎w */
/*              |||            00=type1 - SCK10=H, SO10=, SI10= */
/*              |||            01=type2 - SCK10=H, SO10=, SI10= */
/*              |||            02=type3 - SCK10=L, SO10=, SI10= */
/*              |||            03=type4 - SCK10=L, SO10=, SI10= */
/*              +++-------- reserved */
    CSIE10 = 1;
}

/*
*
*/
void spi_res(void) {
    CSIM10 = 0x00;
}

/*
 *
 */
void main(void) {
    static  UB  rxd[8]; /* Mޯ̧ */
    static  UB  loc;    /* ʒu */
    UH  tmp;            /* Mްޯ̧ */
    UB  stg;

    P1  = 0x00;
    P3  = 0x00;
    P6  = 0x00;
    P12 = 0x00;
    PM1  = 0xFF;
    PM3  = 0x0F;
    PM6  = 0x03;
    PM12 = 0x01;

    for(stg = 0;stg != -1;) {
        tmp = getRecv();
        if(tmp == 0xFF00) {
            continue;
        }
        if(tmp & 0xFF00) {
            stg = -1;
            continue;
        }
        switch(stg) {
            case 0:
                switch(tmp) {
                    case '\033':     stg = -1;     break;
                    case CMD_DDRP0:  stg = 1;      break; // set PM0 (0:output,1:input)
                    case CMD_DDRP1:  stg = 2;      break; // set PM1
                    case CMD_DDRP3:  stg = 3;      break; // set PM3
                    case CMD_DDRP6:  stg = 4;      break; // set PM6
                    case CMD_DDRP12: stg = 5;      break; // set PM12
                    case CMD_INP0:   snddata(P0);  break; // get P0(xxxxxx10)
                    case CMD_INP1:   snddata(P1);  break; // get P1(76543210)
                    case CMD_INP3:   snddata(P3);  break; // get P3(xxxx3210)
                    case CMD_INP6:   snddata(P6);  break; // get P6(xxxxxx10)
                    case CMD_INP12:  snddata(P12); break; // get P12(xxxxx210)
                    case CMD_OUTP0:  stg = 6;      break; // set P0
                    case CMD_OUTP1:  stg = 7;      break; // set P1
                    case CMD_OUTP3:  stg = 8;      break; // set P3
                    case CMD_OUTP6:  stg = 9;      break; // set P6
                    case CMD_OUTP12: stg = 10;     break; // set P12
                    case CMD_SETAD:  spi_ini();    break; // set AD mode
                    case CMD_GETAD:  snd_ad();     break; // get AD
                    case CMD_SETDA:                       // set DA
                        loc = 0;
                        stg = 11;
                        break;
                }
                break;
            case 1:   PM0  = (UB)tmp;  stg = 0;  break;
            case 2:   PM1  = (UB)tmp;  stg = 0;  break;
            case 3:   PM3  = (UB)tmp;  stg = 0;  break;
            case 4:   PM6  = (UB)tmp;  stg = 0;  break;
            case 5:   PM12 = (UB)tmp;  stg = 0;  break;
            case 6:   P0   = (UB)tmp;  stg = 0;  break;
            case 7:
                spi_res();
                P1  = (UB)tmp;
                stg = 0;
                break;
            case 8:   P3   = (UB)tmp;  stg = 0;  break;
            case 9:   P6   = (UB)tmp;  stg = 0;  break;
            case 10:  P12  = (UB)tmp;  stg = 0;  break;
            case 11:
                rxd[loc++] = (UB)tmp;
                if(loc >= 8) {
                    for(loc = 0;loc < 8;loc += 2) {
                        put_da(loc + 1,&rxd[loc]);
                    }
                    stg = 0;
                }
                break;
        }
    }
}
